sealed trait Tree[+A]
case class Leaf[A](value:A) extends Tree[A]
case class Branch[A](left:Tree[A], right:Tree[A]) extends Tree[A]

object Tree {    
    //Exercice 1
    def size[A](t:Tree[A]):Int = t match {
        case Leaf(_) => 1
        case Branch(l, r) => size(l) + size(r) + 1
    }

    //Exercice 2
    def maximum(t:Tree[Int]):Int = t match {
        case Leaf(v) => v
        case Branch(l, r) => maximum(l) max maximum(r)
    }

    //Exercice 3
    def depth[A](t:Tree[A]):Int = t match {
        case Leaf(_) => 0 //1 Si on compte la racine, 0 sinon
        case Branch(l, r) => (depth(l) + 1) max (depth(r) + 1)
    }

    //Exercice 4
    def map[A, B](t:Tree[A])(f:A => B):Tree[B] = t match {
        case Leaf(v) => Leaf(f(v))
        case Branch(l, r) => Branch(map(l)(f), map(r)(f))
    }

    //Exercice 5
    def fold[A, B](t:Tree[A], z:B)(f:(A, B) => B):B = t match {
        case Leaf(v) => f(v, z)
        case Branch(l, r) => fold(l, fold(r, z)(f))(f)
    }

    //Réecritures avec le fold
    def sizeFold[A](t:Tree[A]):Int = fold(t, 1)((_, b) => b + 1)
    def maximumFold(t:Tree[Int]):Int = fold(t, 0)(_ max _)
    //def depthFold[A](t:Tree[A]):Int = fold(t, 0)()
    //def mapFold[A, B](t:Tree[A])(f:A => B):Tree[B] = fold(t, 0)((a, b) => Branch(f(a), b))
}